
#include <Wire.h>
#include <WiiChuck.h>
#include <LiquidCrystal.h>

// select the pins used on the LCD panel
LiquidCrystal lcd(8, 9, 4, 5, 6, 7);

WiiChuck chuck = WiiChuck();

// Werte der Buttons
int lcd_key     = 0;
int adc_key_in  = 0;
int last_lcd_key = 0;
#define btnRIGHT  0
#define btnUP     1
#define btnDOWN   2
#define btnLEFT   3
#define btnSELECT 4
#define btnNONE   5

char answer;
int lastCommunication=0;

unsigned long buttonpressedtime;
boolean selectState=false;
boolean manualState=true;

int lcd_delay=0;
int loop_cnt=0;
int lcd_off=0;
int adjustX=0;
int adjustY=0;
byte accx,accy,accz,zbut,cbut,joyx,joyy;
int PowerLED = 13; // PowerLED




void setup()
{
  pinMode(PowerLED, OUTPUT);
  digitalWrite(PowerLED, HIGH);
  Serial.begin(9600);
  lcd.begin(16, 2);  
  chuck.begin();
  chuck.update();
  chuck.calibrateJoy();
}

void loop()
{
  lcd_key = read_LCD_buttons();   //immer brav guggen, welcher Button gedrückt ist
  
   if ( loop_cnt > 50 ) { // every 50 msecs get new data
    loop_cnt = 0;
    chuck.update();
    tastenverarbeiten(); //verarbeite die Buttonanweisungen
    accx = chuck.readAccelX(); // ranges from approx 70 – 182
    accy = chuck.readAccelY(); // ranges from approx 65 – 173
    accz = chuck.readAccelZ();
    zbut = chuck.buttonZ;
    cbut = chuck.buttonC;
    joyx = chuck.readJoyX()+adjustX; // 20-115-220 links-mitte-rechts
    joyy = chuck.readJoyY()+adjustY; // 36-136-232 unten-mitte-oben
    serialOutput(); //Gibs Seriell aus - oder nicht!
     updateDisplay();
  }
  loop_cnt++; 
  
  
 
    if (zbut=1)
    {
     lcd_off =0; 
    }
    if (cbut=1)
    {
     lcd_off =0; 
    }
  delay(1);
  

  callback();

}

void getNunchuckData()
{

}

int read_LCD_buttons()
{
  adc_key_in = analogRead(0);      // read the value from the sensor 
  // my buttons when read are centered at these valies: 0, 144, 329, 504, 741
  // we add approx 50 to those values and check to see if we are close
  if (adc_key_in > 1000) return btnNONE; // We make this the 1st option for speed reasons since it will be the most likely result
  // For V1.1 us this threshold
  if (adc_key_in < 50)   return btnRIGHT;  
  if (adc_key_in < 250)  return btnUP; 
  if (adc_key_in < 450)  return btnDOWN; 
  if (adc_key_in < 650)  return btnLEFT; 
  if (adc_key_in < 850)  return btnSELECT;  

  // For V1.0 comment the other threshold and use the one below:

  //if (adc_key_in < 50)   return btnRIGHT;  
  //if (adc_key_in < 195)  return btnUP; 
  //if (adc_key_in < 380)  return btnDOWN; 
  //if (adc_key_in < 555)  return btnLEFT; 
  //if (adc_key_in < 790)  return btnSELECT;   



  return btnNONE;  // when all others fail, return this...
}

void tastenverarbeiten()
{

  if(buttonpressedtime+500 < millis()) //alle 500ms 
  {
    if(lcd_key==btnSELECT)
    {
      
      if (!selectState)
      {
       selectState=true; 
       
      }
      else
      {
       selectState=false; 
      }
      lcd_off =0;
      buttonpressedtime = millis();
       
    }

    if(lcd_key==btnRIGHT)
    {

      lcd_off =0;
      buttonpressedtime = millis();      
    }
    if(lcd_key==btnLEFT)
    {
      
      lcd_off =0;
      buttonpressedtime = millis();      
    }
    if(lcd_key==btnUP)
    {
      
      lcd_off =0;
      buttonpressedtime = millis();
      
    }
    if(lcd_key==btnDOWN)
    {
      
      lcd_off =0;
      buttonpressedtime = millis();      
    }
  }
}

void serialOutput()
{
 if (selectState)
 {

 lcd.setCursor(13,0);
 lcd.print("An ");
 Serial.print((byte)joyx,DEC);
 Serial.print(',');
 Serial.print((byte)joyy,DEC);
 Serial.print(',');
 Serial.print((byte)zbut,DEC);
 Serial.print(',');
 Serial.print((byte)cbut,DEC);
 Serial.println('*'); //116;136;0;0* <- Beispiel-Datensatz
 }
 else
 {
 lcd.setCursor(13,0);
 lcd.print("Aus "); 
 }
}


void callback() 
{
  lcd.setCursor(9,1);
 while (Serial.available())
  {
   lastCommunication=0;
   answer = Serial.read();
  } 
  lastCommunication++;
 if ( lcd_delay > 100 ) {  
   lcd_delay=0;
 if (answer == 82) //wenn answer R
 {
  lcd.print("   Runs");
 }
 else if (answer == 83) //wenn answer S
 {
 lcd.print("Stopped");  
 }

if (lastCommunication > 1000) //wenn länger als keine Sekunde keine Antwort kam!
 {
  lcd.setCursor(9,1);
  lcd.print("    n/a"); 
 }
 }
 lcd_delay++;
}


void updateDisplay (){
  
  lcd.setCursor(0,0);
  lcd.print("X:");
  if (joyx <10) {
  lcd.print("00");
  lcd.print(joyx);
  }
  else if (joyx < 100)
  {
  lcd.print("0");
  lcd.print(joyx);
  }
  else
  {
  lcd.print(joyx); 
  }
  lcd.setCursor(0,1);
  lcd.print("Y:");
 if (joyy <10) {
  lcd.print("00");
  lcd.print(joyy);
  }
  else if (joyy < 100)
  {
  lcd.print("0");
  lcd.print(joyy);
  }
  else
  {
  lcd.print(joyy); 
  }
 
  

  if (lcd_off > 1000)
  {
    lcd.noBacklight();
  }
  lcd_off++; 
}

